<?xml version='1.0' encoding='UTF-8'?>
<!--
  ~ iParapheur-Server
  ~ Copyright (C) 2017 Libriciel
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as
  ~ published by the Free Software Foundation, either version 3 of the
  ~ License, or (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  -->

<!DOCTYPE beans PUBLIC '-//SPRING//DTD BEAN//EN' 'http://www.springframework.org/dtd/spring-beans.dtd'>
<beans>

    <!-- Beans definitions for web API access -->
    <bean id="webscript.seals.create.post"
          class="fr.libriciel.parapheur.api.seals.webscripts.CreateSealCertWebscript"
          parent="webscript">
        <property name="certificatesKey" value="${parapheur.cachetserver.security.key}"/>
    </bean>
    <bean id="webscript.seals.update.post"
          class="fr.libriciel.parapheur.api.seals.webscripts.UpdateSealCertWebscript"
          parent="webscript">
        <property name="certificatesKey" value="${parapheur.cachetserver.security.key}"/>
    </bean>
    <bean id="webscript.seals.destroy.delete"
          class="fr.libriciel.parapheur.api.seals.webscripts.DeleteSealCertWebscript"
          parent="webscript">
    </bean>
    <bean id="webscript.seals.list.get"
          class="fr.libriciel.parapheur.api.seals.webscripts.ListSealCertWebscript"
          parent="webscript">
    </bean>

    <!-- Actions -->
    <bean id="webscript.seals.actions.mailforwarn.get"
          class="fr.libriciel.parapheur.api.seals.webscripts.actions.GetMailForWarnMailWebscript"
          parent="webscript">
    </bean>
    <bean id="webscript.seals.actions.mailforwarn.post"
          class="fr.libriciel.parapheur.api.seals.webscripts.actions.SetMailForWarnMailWebscript"
          parent="webscript">
    </bean>

    <!-- Beans definitions for automated jobs -->
    <bean id="fr.libriciel.parapheur.api.seals.jobs.WarnExpirationSealJobExecuter"
          class="fr.libriciel.parapheur.api.seals.jobs.WarnExpirationSealJobExecuter">
        <property name="serviceRegistry" ref="ServiceRegistry"/>
        <property name="daysUntilExpiration" value="${parapheur.cachetserver.warnexpiration.daysuntilexpiration}"/>
    </bean>

    <bean id="fr.libriciel.parapheur.api.seals.warnexpirationseal.jobDetail" class="org.springframework.scheduling.quartz.JobDetailBean">
        <property name="jobClass" value="fr.libriciel.parapheur.api.seals.jobs.WarnExpirationSealJob"/>
        <property name="jobDataAsMap">
            <map>
                <entry key="jobExecuter" value-ref="fr.libriciel.parapheur.api.seals.jobs.WarnExpirationSealJobExecuter"/>
                <entry key="jobLockService" value-ref="jobLockService"/>
            </map>
        </property>
    </bean>

    <bean id="fr.libriciel.parapheur.api.seals.warnexpirationseal.trigger" class="org.alfresco.util.CronTriggerBean">
        <property name="jobDetail" ref="fr.libriciel.parapheur.api.seals.warnexpirationseal.jobDetail"/>
        <property name="scheduler" ref="schedulerFactory"/>
        <property name="cronExpression" value="${parapheur.cachetserver.warnexpiration.cronexpression}"/>
    </bean>
</beans>
